#include "stdafx.h"
#include "atsplugin.h"
#include "Atsp.h"

CAtsp::CAtsp()
{
}

CAtsp::~CAtsp()
{
}

// 
void CAtsp::InitP()
{
	m_approachLampOld = 0;
	init();
}

// ATS-SNɐؑ
void CAtsp::Exit()
{
	if(AtspLamp){blowBell(false);}
	init();
}

// nqʉ
void CAtsp::PassedSig(float distance)
{
	startAtsp();
	m_DistSig = distance - ATSP_VO;
}

// 푬xnqʉ
void CAtsp::PassedSpeedLim(int speed, int distance)
{
	startAtsp();
	m_limSpd = speed;
	m_DistLimSpd = distance - ATSP_OFFSET;
}

// ōxݒ
void CAtsp::PassedSpeedMax(int speed)
{
	startAtsp();
	m_maxSpd = speed;
}

// ~()nqʉ
void CAtsp::PassedStopEmg(float distance)
{
	startAtsp();
	m_DistSig = distance - ATSP_VO;

	if(distance < 50 && *TrainSpeed != 0){applyEmgBrake();}
}

// ~(p)nqʉ
void CAtsp::PassedStopSvc(float distance)
{
	startAtsp();
	m_DistSig = distance - ATSP_VO;

	if(distance < 50 && *TrainSpeed != 0){applyBrake(0);}
}

// A
void CAtsp::Reset()
{
	if(EmergencyBrake && *BrakeNotch == EmergencyNotch){EmergencyBrake = false;} // u[L̏ꍇ
	if(ServiceBrake && *BrakeNotch >= ServiceNotch){ServiceBrake = false;} // pu[L̏ꍇ

	if(!EmergencyBrake && !ServiceBrake)
	{
		BrakeApplyLamp = 0; // u[L\
		ApproachLamp = 0; // p^[ڋߕ\
	}
}

void CAtsp::RunP()
{
	float speed = fabsf(*TrainSpeed); // x̐Βl[km/h]
    float def = speed / 3600 * *DeltaT; // 1t[œ(Βl)[m]
	m_DistSig -= def; // c苗Z
	m_DistLimSpd -= def; // c苗Z
	if(m_DistLimSpd < 0){m_DistLimSpd = 2000000;} // _zp^[

	// ތm
	if(*TrainSpeed * *Reverser < -6){applyEmgBrake();}

	// p^[vZ
	float patternSig = speed * speed / ATSP_DECELERATION; // ~M
	float pSeepdLim = (speed * speed - m_limSpd * m_limSpd) / ATSP_DECELERATION; // x

	// ɉ
	if(ServiceBrake)
	{
		// ڕWxȉɂȂ邩ڋ߃p^[(Abv)ɉ
		if(speed < m_target || (patternSig < m_DistSig - 50 && m_target <= 0))
		{
			ServiceBrake = false;
			BrakeApplyLamp = 0;
			ApproachLamp = 0; // p^[
		}
	}

	// u[L
	if(!ServiceBrake && !EmergencyBrake)
	{
		// p^[ڋ
		if(patternSig >= m_DistSig - 50 && m_DistSig > -50 - ATSP_VO || 
		   pSeepdLim >= m_DistLimSpd - 50 && m_DistLimSpd > 0 && speed >= m_limSpd ||
		   speed >= m_maxSpd - 5)
		{
			ApproachLamp = 1; // p^[ڋ
		}
		else
		{
			ApproachLamp = 0; // p^[
		}
		
		// u[L
		if(patternSig >= m_DistSig && speed >= 16 && m_DistSig > -50 - ATSP_VO) // ~Mɑ΂u[Lp^[
		{
			applyBrake(0);
		}
		if(pSeepdLim >= m_DistLimSpd && m_DistLimSpd > 0) // xɑ΂u[Lp^[
		{
			applyBrake(m_limSpd - 5);
		}
		if(speed >= m_maxSpd + 1) // ōxɑ΂u[Lp^[
		{
			applyBrake(m_maxSpd - 5);
		}
	}

	if(ApproachLamp != m_approachLampOld)
	{
		blowBell((bool)m_approachLampOld); // PŃx炷
		m_approachLampOld = ApproachLamp;
	}

	Bell = m_bell; // TEhXV
	m_bell = ATS_SOUND_CONTINUE; // CONTINUEɂĂ
}

// 
void CAtsp::init()
{
	m_DistSig = -50 - ATSP_VO; // ~\_
	m_DistLimSpd = 0; // x
	m_maxSpd = 370; // ōx[km/h]
	ApproachLamp = 0; // p^[ڋߕ\
	BrakeApplyLamp = 0; // u[L\
	ServiceBrake = false; // pu[L
	EmergencyBrake = false; // u[L
	AtspLamp = 0; // ATS-P\
}

// ATS-P
void CAtsp::startAtsp()
{
	if(AtspLamp == 0)
	{
		AtspLamp = 1; // ATS-P\_
		blowBell(false); // PŃx炷
	}
}

// u[L
void CAtsp::applyBrake(int targetSpeed)
{
	ServiceBrake = true;
	BrakeApplyLamp = 1; // u[L\_
	m_target = targetSpeed; // ڕWx
}

// PŃx炷
void CAtsp::blowBell(bool off)
{
	if(*TrainSpeed != 0 || off){m_bell = ATS_SOUND_PLAY;} // wWvɂ͖炳Ȃ
}

// u[L
void CAtsp::applyEmgBrake()
{
	EmergencyBrake = true; // u[L
	BrakeApplyLamp = 1; // u[L\_
	ApproachLamp = 1; // p^[ڋߕ\_
}