#include "stdafx.h"
#include "atsplugin.h"
#include "Atssn.h"

CAtssn::CAtssn(void)
{
}

CAtssn::~CAtssn(void)
{
}

void CAtssn::RunSn(void)
{
	// ATS쓮
	if(m_atsAlarm == 2)
	{
		if(*Time >= m_tmrAtspassAlarm && m_tmrAtspassAlarm){cancelAts();} // N`Cؑ

		if(*Time >= m_tmrAts && !AtsBrake)
		{
			AtsBrake = true;
			// bZ[WuATS舵sǂłv
		}

		// ԐF_
		if(AtsBrake)
		{
			int n = (*Time % 750) / 375;
			RedLamp = n;
			m_blnAtsLamp = n;
		}
	}
}

// ATSmF
void CAtssn::CheckAts(void)
{
	if(*Notch >= CancelNotch && m_atsButton){cancelAts();} // ATSmF
}

// 
void CAtssn::InitSn(void)
{
	AtsBrake = false;
	m_atsAlarm = 0;
	Bell = ATS_SOUND_STOP;
	Chime = ATS_SOUND_STOP;
	WhiteLamp = 1;
	RedLamp = 0;
}

// ATSmF{^
void CAtssn::DownButtom(void)
{
	m_atsButton = true;
	CheckAts();
}

// `C
void CAtssn::CancelChime(void)
{
	if(m_atsAlarm == 1)
	{
        m_atsAlarm = 0;
		Chime = ATS_SOUND_STOP;
        // bZ[Wu`C~߂Ă͂܂v
	}
}

// ATSmF{^𗣂
void CAtssn::UpButton(void)
{
	m_atsButton = false;
}

// Onqʉ
void CAtssn::PassedLong(int signal)
{
	if(signal == 0)
	{
		if(m_atsAlarm != 2)
		{
			m_tmrAts = *Time + 5000;
			m_tmrAtspassAlarm = 0;
			alarmSound();
			// bZ[WuATSmFĂv
		}
	}
	else if(WhiteLamp == 0)
	{
		m_tmrAts = *Time + 5000;
		m_tmrAtspassAlarm = *Time + 375;
		alarmSound();
	}
}

// nqʉ
void CAtssn::PassedShort(int signal)
{
	if(signal == 0)
	{
		if(!AtsBrake)
		{
			AtsBrake = true; // u[L
			// bZ[WuMȂv
			if(m_atsAlarm != 2){alarmSound();}
		}
	}
	else if(WhiteLamp == 0)
	{
		m_tmrAts = *Time + 5000;
		m_tmrAtspassAlarm = *Time + 375;
		alarmSound();
	}
}

// A
void CAtssn::Reset(void)
{
	if(*Notch == EmgNotch && AtsBrake)
	{
		AtsBrake = false; // u[Lɉ
		m_atsAlarm = 0; // `Cߒ
		Bell = ATS_SOUND_STOP; // x~
		WhiteLamp = 1; // F_
		RedLamp = 0; // ԐFœ
	}
}

// J
void CAtssn::TurnOff()
{
	AtsBrake = false; // u[Lɉ
	m_atsAlarm = 0; // `Cߒ
	Bell = ATS_SOUND_STOP; // x~
	Chime = ATS_SOUND_STOP; // `C~
	WhiteLamp = 0; // Fœ
	RedLamp = 0; // ԐFœ
}

// ATSmF
void CAtssn::cancelAts()
{
	if(m_atsAlarm == 2 && !AtsBrake)
	{
		m_atsAlarm = 1; // `Cߒ
		Bell = ATS_SOUND_STOP; // x~
		Chime = ATS_SOUND_PLAYLOOPING; // `C
		WhiteLamp = 1; // F_
		RedLamp = 0; // ԐFœ
	}
}

// ATSx炷
void CAtssn::alarmSound(void)
{
	m_atsAlarm = 2; // xߒ
	m_blnAtsLamp = true; // ԐF_
	Chime = ATS_SOUND_STOP; // `C~
	Bell = ATS_SOUND_PLAYLOOPING; // x
	WhiteLamp = 0; // Fœ
	RedLamp = 1; // ԐF_
}